#include <cassert>
#include <vector>
#include <iostream>
#include "rapidmix.h"

int main() {
    
    ///////////////////////////////////Test GVF
    
    rapidmix::gvfTemporalVariation gvf;
    rapidmix::trainingData myGVFData;
    
    // Record first gesture
    myGVFData.startRecording();
    myGVFData.addElement({ 4.0, 0.7 });
    myGVFData.addElement({ 3.0, 0.8 });
    myGVFData.addElement({ 2.0, 0.9 });
    myGVFData.addElement({ 1.0, 1.0 });
    myGVFData.addElement({ 0.4, 1.2 });
    myGVFData.addElement({ 0.2, 1.4 });
    myGVFData.stopRecording();
    
    // Record reverse of first gesture
    myGVFData.startRecording();
    myGVFData.addElement({ 0.2, 1.4 });
    myGVFData.addElement({ 0.4, 1.2 });
    myGVFData.addElement({ 1.0, 1.0 });
    myGVFData.addElement({ 2.0, 0.9 });
    myGVFData.addElement({ 3.0, 0.8 });
    myGVFData.addElement({ 4.0, 0.7 });
    myGVFData.stopRecording();
    
    // Train
    std::cout << "gvf train = " << gvf.train(myGVFData) << std::endl;
    
    std::cout << "gvf passed." << std::endl;
    
    //////////////////////////////////////Test RapidLib
    
    rapidmix::staticRegression myNN;
    rapidmix::trainingData myRLData;
    
    std::vector<double> input = { 0.2, 0.7 };
    std::vector<double> output = { 3.0 };
    myRLData.recordSingleElement("label", input, output);
    
    input = { 2.0, 44.2 };
    output = { 20.14 };
    myRLData.recordSingleElement("label", input, output);
    
    std::cout << "staticRegression train = " << myNN.train(myRLData) << std::endl;
    
    std::vector<double> inputVec = { 1.618, 18.9 };
    assert(myNN.run(inputVec)[0] == 12.596715279688549);
    std::cout << "staticRegression passed." << std::endl;
    
    return 0;
}
